local f = CreateFrame("Frame")
RegisterAddonMessagePrefix("EnRT_VMT")
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("UNIT_AURA")
f:RegisterEvent("ENCOUNTER_START")
f:RegisterEvent("ENCOUNTER_END")
--Scopes
local soaker = "" -- MASTER
local master = "" -- ALL
local tracker = 0 -- MASTER
local player = UnitName("player") -- ALL
local timer = "" -- ALL
local debuffed = "" -- MASTER
local tempList = ""
local list = CreateFrame("Frame")
list:SetPoint("TOPLEFT")
list:SetSize(100, 240)
list:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", --Set the background and border textures
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
	tile = true, tileSize = 16, edgeSize = 16, 
	insets = { left = 4, right = 4, top = 4, bottom = 4 }
})
list:SetBackdropColor(0,0,0,1)
list:SetMovable(false)
list:EnableMouse(false)
list:RegisterForDrag("LeftButton")
list:SetFrameStrata("HIGH")
list:SetFrameLevel(8)
list:SetClampedToScreen(true)
list:SetScript("OnDragStop", function(self)
	local point, relativeTo, relativePoint, xOffset, yOffset = self:GetPoint(1)
	EnRT_VarimathrasListPos = {}
	EnRT_VarimathrasListPos.point = point
	EnRT_VarimathrasListPos.relativeTo = relativeTo
	EnRT_VarimathrasListPos.relativePoint = relativePoint
	EnRT_VarimathrasListPos.xOffset = xOffset
	EnRT_VarimathrasListPos.yOffset = yOffset
	self:StopMovingOrSizing()
end)
list:SetScript("OnDragStart", list.StartMoving)
list:Hide()
local listText = list:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
listText:SetPoint("TOPLEFT", 15, -15)
listText:SetSize(80, 220)
listText:SetJustifyH("LEFT")
listText:SetJustifyV("TOP")
f:SetScript("OnEvent", function(self, event, ...)
	if EnRT_VarimathrasEnabled and tempList then
		if event == "ENCOUNTER_START" then
			local eID = ...
			local difficulty = select(3, GetInstanceInfo())
			if eID == 2069 and difficutly == 15 or difficulty == 16 then
				if tempList then
					--create visual list
					tempList = EnRT_VarimathrasList
					local first, second = EnRT_GetNextSoakers()
					soaker = first
					if UnitIsConnected(first) and UnitInRaid(first) then
						SendAddonMessage("EnRT_VMT", "SOAKING NEXT", "WHISPER", first)
					end
					if UnitIsConnected(second) and UnitInRaid(second) then
						SendAddonMessage("EnRT_VMT", "BACKUP FOR NEXT", "WHISPER", second)
					end
					EnRT_UpdateVarimathrasList()
				end
			end
		elseif event == "ENCOUNTER_END" then
			if list:IsShown() then
				list:Hide()
			end
		elseif event == "CHAT_MSG_ADDON" then
			local prefix, msg, channel, sender = ...
			if prefix == "EnRT_VMT" then
				if timer ~= "" then
					EnRT_PopupHide()
					timer:Cancel()
				end
				if msg ~= "" then
					if msg == "SOAKING NEXT" then
						soaker = GetUnitName("player", true)
					end
					timer = EnRT_PopupShow(msg, 500)
				end
			end
		elseif event == "UNIT_AURA" and tempList and player == master then
			local unit = ...
			if UnitDebuff(unit, GetSpellInfo(244093)) and debuffed == "" then
				debuffed = GetUnitName(unit, true)
				C_Timer.After(6, function()
					if UnitIsConnected(soaker) and UnitInRaid(soaker) then
						SendAddonMessage("ENRT_VMT", "", "WHISPER", soaker)
					end
					local first, second = EnRT_GetNextSoakers()
					soaker = first
					if UnitIsConnected(first) and UnitInRaid(first) then
						SendAddonMessage("EnRT_VMT", "SOAKING NEXT", "WHISPER", first)
					end
					if UnitIsConnected(second) and UnitInRaid(second) then
						SendAddonMessage("EnRT_VMT", "BACKUP FOR NEXT", "WHISPER", second)
					end
					EnRT_UpdateVarimathrasList()
				end)
			end
			if soaker == debuffed and UnitDebuff(unit, GetSpellInfo(244093)) then -- Necrotic Embrace
				--Backup initation
				local tempFirst = soaker
				local tempIndex = EnRT_Contains(tempList, soaker)
				if UnitIsConnected(soaker) and UnitInRaid(soaker) then
					SendAddonMessage("ENRT_VMT", "", "WHISPER", soaker)
				end
				local first = EnRT_GetNextSoakers()
				soaker = first
				if UnitIsConnected(first) and UnitInRaid(first) then
					SendAddonMessage("EnRT_VMT", "SOAK NOW", "WHISPER", first)
				end
				EnRT_UpdateVarimathrasList()
			end
		end
	end
	if event == "PLAYER_LOGIN" then
		if EnRT_VarimathrasEnabled == nil then EnRT_VarimathrasEnabled = true end
		if EnRT_VarimathrasListPos then 
			EnRT_SetVarimathrasListPosition(EnRT_VarimathrasListPos.point, EnRT_VarimathrasListPos.relativeTo, EnRT_VarimathrasListPos.relativePoint, EnRT_VarimathrasListPos.xOffset, EnRT_VarimathrasListPos.yOffset)
		end
		if EnRT_VarimathrasListShow == nil then EnRT_VarimathrasListShow = true end
	end
end)
--[[
	Checking if a table contains a given value and if it does, what index is the value located at
	param(arr) table
	param(value) T - value to check exists
	return boolean or integer / returns false if the table does not contain the value otherwise it returns the index of where the value is locatedd
]]
function EnRT_Contains(arr, value)
	if value == nil then
		return false
	end
	if arr == nil then
		return false
	end
	for k, v in pairs(arr) do
		if v == value then
			return k
		end
	end
	return false
end
function EnRT_GetRaidLeader()
	for i = 1, GetNumGroupMembers() do
		local raider = "raid"..i
		if select(2, GetRaidRosterInfo(i)) == 2 then
			return GetUnitName(raider, true)
		end
	end
	return ""
end
function EnRT_GetNextSoakers()
	local first = ""
	local second = ""
	tracker = tracker + 1
	for i = tracker, #tempList do
		local pl = tempList[tracker]
		if not UnitIsDead(pl) then
			if pl == "" then
				first = pl
			else
				second = pl
				tracker = i
			end
		end
	end
	if first == "" or second == "" then
		tracker = 1
		for i = tracker, #tempList do
			local pl = tempList[tracker]
			if not UnitIsDead(pl) then
				if pl == "" then
					first = pl
				else
					second = pl
					tracker = i
				end
			end
		end
	end
	return first, second
end
function EnRT_InitVarimathrasList()
	local text = "\124cFFFFFF00Soakers:\124r \n"
	tempList = EnRT_VarimathrasList
	if tempList then 
		for k, v in pairs(tempList) do
			local short = Ambiguate(v, "short")
			text = text .. short .. "\n"
		end
	end
	listText:SetText(text)
	list:Show()
end
function EnRT_UpdateVarimathrasList()
	local text = "\124cFFFFFF00Soaker:\124r \n"
	for k, v in pairs(tempList) do
		local prefix = ""
		local suffix = ""
		local short = Ambiguate(v, "short")
		if UnitIsDead(v) then
			prefix = "\124cFF7F7F7F"
			suffix = "\124r"
		elseif GetUnitName(v, true) == soaker then
			prefix = "\124cFF00FF00>"
			suffix = "\124r"
		end
		text = text .. prefix ..  short .. suffix .. "\n"
	end
	listText:SetText(text)
	list:Show()
end

function EnRT_SetVarimathrasListPosition(point, relativeTo, relativePoint, xOffset, yOffset)
	list:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
end

function EnRT_VarimathrasListMove()
	list:SetMovable(true)
	list:EnableMouse(true)
	list:Show()
	C_Timer.After(7, function() 
		list:Hide()
		list:SetMovable(false)
		list:EnableMouse(false)
	end)
end